﻿namespace Excel.Core.BinaryFormat
{
    using System;

    internal enum BIFFRECORDTYPE : ushort
    {
        INTERFACEHDR = 0xe1,
        MMS = 0xc1,
        INTERFACEEND = 0xe2,
        WRITEACCESS = 0x5c,
        CODEPAGE = 0x42,
        DSF = 0x161,
        TABID = 0x13d,
        FNGROUPCOUNT = 0x9c,
        WINDOWPROTECT = 0x19,
        PROTECT = 0x12,
        PASSWORD = 0x13,
        PROT4REV = 0x1af,
        PROT4REVPASSWORD = 0x1bc,
        WINDOW1 = 0x3d,
        BACKUP = 0x40,
        HIDEOBJ = 0x8d,
        RECORD1904 = 0x22,
        REFRESHALL = 0x1b7,
        BOOKBOOL = 0xda,
        FONT = 0x31,
        FONT_V34 = 0x231,
        FORMAT = 0x41e,
        FORMAT_V23 = 30,
        XF = 0xe0,
        XF_V4 = 0x443,
        XF_V3 = 0x243,
        XF_V2 = 0x43,
        STYLE = 0x293,
        BOUNDSHEET = 0x85,
        COUNTRY = 140,
        SST = 0xfc,
        CONTINUE = 60,
        EXTSST = 0xff,
        BOF = 0x809,
        BOF_V2 = 9,
        BOF_V3 = 0x209,
        BOF_V4 = 0x409,
        EOF = 10,
        CALCCOUNT = 12,
        CALCMODE = 13,
        PRECISION = 14,
        REFMODE = 15,
        DELTA = 0x10,
        ITERATION = 0x11,
        SAVERECALC = 0x5f,
        PRINTHEADERS = 0x2a,
        PRINTGRIDLINES = 0x2b,
        GUTS = 0x80,
        WSBOOL = 0x81,
        GRIDSET = 130,
        DEFAULTROWHEIGHT = 0x225,
        HEADER = 20,
        FOOTER = 0x15,
        HCENTER = 0x83,
        VCENTER = 0x84,
        PRINTSETUP = 0xa1,
        DFAULTCOLWIDTH = 0x55,
        DIMENSIONS = 0x200,
        ROW = 520,
        WINDOW2 = 0x23e,
        SELECTION = 0x1d,
        INDEX = 0x20b,
        DBCELL = 0xd7,
        BLANK = 0x201,
        BLANK_OLD = 1,
        MULBLANK = 190,
        INTEGER = 0x202,
        INTEGER_OLD = 2,
        NUMBER = 0x203,
        NUMBER_OLD = 3,
        LABEL = 0x204,
        LABEL_OLD = 4,
        LABELSST = 0xfd,
        FORMULA = 0x406,
        FORMULA_OLD = 6,
        BOOLERR = 0x205,
        BOOLERR_OLD = 5,
        ARRAY = 0x221,
        RK = 0x27e,
        MULRK = 0xbd,
        RSTRING = 0xd6,
        SHRFMLA = 0x4bc,
        SHRFMLA_OLD = 0xbc,
        STRING = 0x207,
        CF = 0x1b1,
        CODENAME = 0x1ba,
        CONDFMT = 0x1b0,
        DCONBIN = 0x1b5,
        DV = 0x1be,
        DVAL = 0x1b2,
        HLINK = 440,
        MSODRAWINGGROUP = 0xeb,
        MSODRAWING = 0xec,
        MSODRAWINGSELECTION = 0xed,
        PARAMQRY = 220,
        QSI = 0x1ad,
        SUPBOOK = 430,
        SXDB = 0xc6,
        SXDBEX = 290,
        SXFDBTYPE = 0x1bb,
        SXRULE = 240,
        SXEX = 0xf1,
        SXFILT = 0xf2,
        SXNAME = 0xf6,
        SXSELECT = 0xf7,
        SXPAIR = 0xf8,
        SXFMLA = 0xf9,
        SXFORMAT = 0xfb,
        SXFORMULA = 0x103,
        SXVDEX = 0x100,
        TXO = 0x1b6,
        USERBVIEW = 0x1a9,
        USERSVIEWBEGIN = 0x1aa,
        USERSVIEWEND = 0x1ab,
        USESELFS = 0x160,
        XL5MODIFY = 0x162,
        OBJ = 0x5d,
        NOTE = 0x1c,
        SXEXT = 220,
        VERTICALPAGEBREAKS = 0x1a,
        XCT = 0x59,
        UNCALCED = 0x5e,
        QUICKTIP = 0x800
    }
}

